
class RequestManager:
    def __init__(self,request):
        self.request = request

    def getPath(self):
        return self.getRequest().path

    def getPage(self):
        return self.getPath().replace("/", "")

    def getRule(self):
        return self.getRequest().url_rule.rule

    def getFromPost(self,attributeName):
        if self.existInPost(attributeName):
            data = self.request.form[attributeName]
            if data:
                return data
            else:
                raise Exception()
        else:
            raise Exception()

    def getFromGet(self,attributeName):
        if self.existInGet(attributeName):
            data = self.request.args[attributeName]
            if data:
                return data
            else:
                raise Exception()
        else:
            raise Exception()


    def getFromGetSafe(self,attributeName):
        if self.existInGet(attributeName):
            data = self.request.args[attributeName]
            if data:
                return data
            else:
                return 0
        else:
            return 0

    def existInPost(self, attributeName):
        if attributeName in self.request.form:
            return True
        else:
            return False

    def existInGet(self, attributeName):
        if attributeName in self.request.args:
            return True
        else:
            return False

    def getRequest(self):
        return self.request