from __future__ import print_function # In python 2.7
import sys
from flask import Flask
from flask import request
from api_request_manager import *
from data_holder import DataHolder




# user weights
userWeights = {}
userWeights["blizkost_kontaminace"] = 1
userWeights["hluk_2012"] = 1
userWeights["plocha_zelene_osm"] = 1
userWeights["frekventovana_silnice_score"] = 1
userWeights["znecisteni_ovzdusi_prekroceni"] = 1

data = DataHolder(select_keys="blizkost_kontaminace,hluk_2012,plocha_zelene_osm,frekventovana_silnice_score,znecisteni_ovzdusi_prekroceni",special_keys="kod")
data.downloadFromCarto(cacheFile="zivotni_prostredi.pickle", fromCache=True)

# data preparation
data.removeOutliners(user_except_keys=["blizkost_kontaminace"])
# data.standardizeData()
data.normalizeData()
data.reverseDataScale(user_except_keys=["plocha_zelene_osm"])
# show data
# data.showKeysPlots(histPlots=True)

# WPCA
data.setWPCAWeights(userWeights=userWeights)
data.runWPCA()
# normalize output
data.normalizeOutput(normalize=True, removeOutliners=False)

# export data
data.uploadToCarto(table="results_zivotni_prostredi")






















