from flask import jsonify
from api_request_manager import *

class UserWeights:
    def __init__(self,requestManager):
        self.page = requestManager.getPage()
        self.requestManager = requestManager
        self.userWeights = {}
        self.userWeights["pouze_obytne"] = 0

    def setUserWeightsAll(self):
        userWeights = self.userWeights
        userWeights["pouze_obytne"] = int(self.requestManager.getFromGetSafe('pouze_obytne'))
        userWeights["blizkost_kontaminace"] = float(self.requestManager.getFromGetSafe('blizkost_kontaminace'))
        userWeights["hluk_2012"] = float(self.requestManager.getFromGetSafe('hluk'))
        userWeights["plocha_zelene_osm"] = float(self.requestManager.getFromGetSafe('plocha_zelene'))
        userWeights["frekventovana_silnice_score"] = float(self.requestManager.getFromGetSafe('frekventovane_silnice'))
        userWeights["znecisteni_ovzdusi_prekroceni"] = float(self.requestManager.getFromGetSafe('znecisteni_ovzdusi'))
        userWeights["zaplavove_uzemi_aktivni_score"] = float(self.requestManager.getFromGetSafe('zaplavove_uzemi'))
        userWeights["cena_nemovitosti"] = float(self.requestManager.getFromGetSafe('cena_nemovitosti'))
        userWeights["pomer_obytnych_budov"] = float(self.requestManager.getFromGetSafe('pomer_obytnych_budov'))
        userWeights["okolni_pocet_podlazi"] = float(self.requestManager.getFromGetSafe('okolni_pocet_podlazi'))
        userWeights["plocha_brownfiled"] = float(self.requestManager.getFromGetSafe('plocha_brownfiled'))
        userWeights["v_obytne_zone"] = float(self.requestManager.getFromGetSafe('v_obytne_zone'))
        userWeights["v_residencni_ulici"] = float(self.requestManager.getFromGetSafe('v_residencni_ulici'))
        userWeights["internet"] = float(self.requestManager.getFromGetSafe('internet'))
        userWeights["hustota_zalidneni"] = float(self.requestManager.getFromGetSafe('hustota_zalidneni'))
        userWeights["podil_romske_narodnosti"] = float(self.requestManager.getFromGetSafe('podil_romske_narodnosti'))
        userWeights["podil_postproduktivni_obyvatel"] = float(self.requestManager.getFromGetSafe('podil_postproduktivni_obyvatel'))
        userWeights["facebook_navstevnost"] = float(self.requestManager.getFromGetSafe('facebook_navstevnost'))
        userWeights["kriminalita"] = float(self.requestManager.getFromGetSafe('kriminalita'))
        userWeights["pocitova_mapa"] = float(self.requestManager.getFromGetSafe('pocitova_mapa'))
        userWeights["recyklokontejner_vzdalenost"] = float(self.requestManager.getFromGetSafe('kontejnery'))
        userWeights["posta_vzdalenost"] = float(self.requestManager.getFromGetSafe('posty'))
        userWeights["potraviny_vzdalenost"] = float(self.requestManager.getFromGetSafe('potraviny'))
        userWeights["hospodybary_vzdalenost"] = float(self.requestManager.getFromGetSafe('hospody'))
        userWeights["obchody_plocha"] = float(self.requestManager.getFromGetSafe('obchodni_plocha'))
        userWeights["restaurace_vzdalenost"] = float(self.requestManager.getFromGetSafe('restaurace'))
        userWeights["mhd_vzdalenost"] = float(self.requestManager.getFromGetSafe('mhd_vzdalenost'))
        userWeights["mhd_ceska"] = float(self.requestManager.getFromGetSafe('mhd_ceska'))
        userWeights["mhd_mendlak"] = float(self.requestManager.getFromGetSafe('mhd_mendlak'))
        userWeights["mhd_skacelova"] = float(self.requestManager.getFromGetSafe('mhd_skacelova'))

    def getUserWeightsAll(self):
        return self.userWeights


    def initWeightsFromList(self,list):
        userWeights = self.userWeights
        for item in list:
            userWeights[item] = 1.0

    """
    def setUserWeights(self,page,userWeights):
        if page == "zivotni_prostredi":
            userWeights["blizkost_kontaminace"] = float(self.requestManager.getFromGet('blizkost_kontaminace'))
            userWeights["hluk_2012"] = float(self.requestManager.getFromGet('hluk'))
            userWeights["plocha_zelene_osm"] = float(self.requestManager.getFromGet('plocha_zelene'))
            userWeights["frekventovana_silnice_score"] = float(self.requestManager.getFromGet('frekventovane_silnice'))
            userWeights["znecisteni_ovzdusi_prekroceni"] = float(self.requestManager.getFromGet('znecisteni_ovzdusi'))
        elif page == "nemovitosti":
            userWeights["zaplavove_uzemi_aktivni_score"] = float(self.requestManager.getFromGet('zaplavove_uzemi'))
            userWeights["cena_nemovitosti"] = float(self.requestManager.getFromGet('cena_nemovitosti'))
            userWeights["pomer_obytnych_budov"] = float(self.requestManager.getFromGet('pomer_obytnych_budov'))
            userWeights["okolni_pocet_podlazi"] = float(self.requestManager.getFromGet('okolni_pocet_podlazi'))
            userWeights["plocha_brownfiled"] = float(self.requestManager.getFromGet('plocha_brownfiled'))
            userWeights["v_obytne_zone"] = float(self.requestManager.getFromGet('v_obytne_zone'))
            userWeights["v_residencni_ulici"] = float(self.requestManager.getFromGet('v_residencni_ulici'))
            userWeights["internet"] = float(self.requestManager.getFromGet('internet'))
        elif page == "socialni":
            userWeights["hustota_zalidneni"] = float(self.requestManager.getFromGet('hustota_zalidneni'))
            userWeights["podil_romske_narodnosti"] = float(self.requestManager.getFromGet('podil_romske_narodnosti'))
            userWeights["podil_postproduktivni_obyvatel"] = float(self.requestManager.getFromGet('podil_postproduktivni_obyvatel'))
            userWeights["facebook_navstevnost"] = float(self.requestManager.getFromGet('facebook_navstevnost'))
            userWeights["kriminalita"] = float(self.requestManager.getFromGet('kriminalita'))
            userWeights["pocitova_mapa"] = float(self.requestManager.getFromGet('pocitova_mapa'))
        elif page == "sluzby":
            userWeights["recyklokontejner_vzdalenost"] = float(self.requestManager.getFromGet('kontejnery'))
            userWeights["posta_vzdalenost"] = float(self.requestManager.getFromGet('posty'))
            userWeights["potraviny_vzdalenost"] = float(self.requestManager.getFromGet('potraviny'))
            userWeights["hospodybary_vzdalenost"] = float(self.requestManager.getFromGet('hospody'))
            userWeights["obchody_plocha"] = float(self.requestManager.getFromGet('obchodni_plocha'))
            userWeights["restaurace_vzdalenost"] = float(self.requestManager.getFromGet('restaurace'))
        elif page == "doprava":
            userWeights["mhd_vzdalenost"] = float(self.requestManager.getFromGet('mhd_vzdalenost'))
            userWeights["mhd_ceska"] = float(self.requestManager.getFromGet('mhd_ceska'))
            userWeights["mhd_mendlak"] = float(self.requestManager.getFromGet('mhd_mendlak'))
            userWeights["mhd_skacelova"] = float(self.requestManager.getFromGet('mhd_skacelova'))



    def getUserWeights(self):
        userWeights = {}

        if self.page  == "all":
            self.setUserWeights("zivotni_prostredi", userWeights)
            self.setUserWeights("nemovitosti", userWeights)
            self.setUserWeights("doprava", userWeights)
            self.setUserWeights("sluzby", userWeights)
            self.setUserWeights("socialni", userWeights)
        else:
            self.setUserWeights(self.page,userWeights)

        return userWeights

    """