from cartodb import CartoDBAPIKey, CartoDBException
import numpy as np
from sklearn.decomposition import PCA as sklearnPCA
from sklearn.decomposition import KernelPCA as sklearnKernelPCA
import sklearn
import scipy.stats as stats
import pylab as pl
import normalize_easy
from wpca import WPCA, EMPCA


def show_hist(data):
   pl.hist(np.sort(data), normed=False)  # use this to draw histogram of your data
   pl.show()

def show_boxplot(data,xlabel,ylabel,filename,show=True,save=True,y_0_1=False):
    try:
        pl.clf()
        pl.boxplot(data)
        pl.xlabel(xlabel)
        pl.ylabel(ylabel)
        if y_0_1:
            axes = pl.gca()
            axes.set_ylim([-0.1, 1.1])
        if save:
            pl.savefig('/home/blue4world/Desktop/graphs/'+filename+'.png', bbox_inches='tight')
        if show:
            pl.show()
        pl.draw()
    except:
        return

def substractOne(array):
   return [1 - x for x in array]


# https://gist.github.com/vishalkuo/f4aec300cf6252ed28d3#file-outlier_removal-py-L3
def removeOutliers(x, outlierConstant=1.5):
    a = np.array(x)
    upper_quartile = np.percentile(a, 75)
    lower_quartile = np.percentile(a, 25)
    IQR = (upper_quartile - lower_quartile) * outlierConstant
    quartileSet = (lower_quartile - IQR, upper_quartile + IQR)
    resultList = []
    for i in a:
       if i >= quartileSet[1]:
          resultList.append(quartileSet[1])
       elif i <= quartileSet[0]:
          resultList.append(quartileSet[0])
       else:
         resultList.append(i)
    return resultList

def removeSmallerThanZero(list):
    newList = []
    for i in list:
        if i <= 0.0:
            newList.append(0)
        else:
            newList.append(i)
    return newList

def PCAresultToSimpleArray(PCA_data):
    data = []
    for i in PCA_data:
        data.append(i[0])
    return data