from cartodb import CartoDBAPIKey, CartoDBException
import numpy as np
from sklearn.decomposition import PCA as sklearnPCA
from sklearn.decomposition import KernelPCA as sklearnKernelPCA
import sklearn
import scipy.stats as stats
import pylab as pl
import normalize_easy
from wpca import WPCA, EMPCA
from functions import *



API_KEY ='a50f67b019a990a1f29893ca6beab24028c2aea0'
cl = CartoDBAPIKey(API_KEY, 'blue4world',host='cartodb.ml', protocol='http')
try:
   #print(cl.sql('select name from restaurace'))
   plocha_zelene_osm = []
   frekventovana_silnice_score = []
   znecisteni_ovzdusi_prekroceni = []
   hluk_2012 = []
   kod = []
   blizkost_kontaminace = []
   the_geom = []
   mo = []
   obj = cl.sql('select the_geom,mo,blizkost_kontaminace,hluk_2012,kod,plocha_zelene_osm,frekventovana_silnice_score,znecisteni_ovzdusi_prekroceni from budovy_index where zpusob_vyuziti_bool = 0 order by kod asc')
   for name in obj[u'rows']:
      plocha_zelene_osm.append(name['plocha_zelene_osm'])
      frekventovana_silnice_score.append(name['frekventovana_silnice_score'])
      znecisteni_ovzdusi_prekroceni.append(name['znecisteni_ovzdusi_prekroceni'])
      kod.append(name['kod'])
      hluk_2012.append(name['hluk_2012'])
      blizkost_kontaminace.append(name['blizkost_kontaminace'])
      the_geom.append(name['the_geom'])
      mo.append(name['mo'])

   # 1 best, 0 worst

   normalized_plocha_zelene_osm =  sklearn.preprocessing.MinMaxScaler().fit_transform(removeOutliers(plocha_zelene_osm))
   normalized_plocha_zelene_osm = removeSmallerThanZero(normalized_plocha_zelene_osm)

   normalized_frekventovana_silnice_score = sklearn.preprocessing.MinMaxScaler().fit_transform(removeOutliers(frekventovana_silnice_score))
   normalized_frekventovana_silnice_score = substractOne(normalized_frekventovana_silnice_score)
   normalized_frekventovana_silnice_score = removeSmallerThanZero(normalized_frekventovana_silnice_score)

   normalized_znecisteni_ovzdusi_prekroceni = sklearn.preprocessing.MinMaxScaler().fit_transform(removeOutliers(znecisteni_ovzdusi_prekroceni))
   normalized_znecisteni_ovzdusi_prekroceni = substractOne(normalized_znecisteni_ovzdusi_prekroceni)
   normalized_znecisteni_ovzdusi_prekroceni = removeSmallerThanZero(normalized_znecisteni_ovzdusi_prekroceni)

   normalized_hluk = sklearn.preprocessing.MinMaxScaler().fit_transform(removeOutliers(hluk_2012))
   normalized_hluk = substractOne(normalized_hluk)
   normalized_hluk = removeSmallerThanZero(normalized_hluk)

   # do not remove outlines from categorical variable
   normalized_blizkost_kontaminace =  sklearn.preprocessing.MinMaxScaler().fit_transform(blizkost_kontaminace)
   normalized_blizkost_kontaminace = substractOne(normalized_blizkost_kontaminace)




   # show histnormalized_blizkost_kontaminace
   #show_hist(normalized_blizkost_kontaminace)
   #pl.boxplot(normalized_blizkost_kontaminace)
   #pl.show()
   #show_hist(normalized_plocha_zelene_osm)
   #show_hist(normalized_frekventovana_silnice_score)
   #show_hist(normalized_znecisteni_ovzdusi_prekroceni)


   data = np.array([normalized_blizkost_kontaminace,normalized_hluk,normalized_plocha_zelene_osm,normalized_frekventovana_silnice_score,normalized_znecisteni_ovzdusi_prekroceni])
   print data.shape

   # PCA
   # http://scikit-learn.org/stable/modules/generated/sklearn.decomposition.PCA.html#sklearn.decomposition.PCA
   sklearn_pca = sklearnPCA(n_components=1,whiten=True)
   sklearn_pca_data = sklearn_pca.fit_transform(data.T)
   # Percentage of variance explained by each of the selected components.
   print sklearn_pca.explained_variance_ratio_
    # WPCA
   # github.com/jakevdp/wpca
   #wpca = WPCA(n_components=1).fit(data.T)
   #wpca_data = WPCA(n_components=1).fit_transform(data.T)
   #print wpca.explained_variance_ratio_

   # normalize PCA
   sklearn_pca_normalized = sklearn.preprocessing.MinMaxScaler().fit_transform(removeOutliers(PCAresultToSimpleArray(sklearn_pca_data)))
   sklearn_pca_normalized = substractOne(sklearn_pca_normalized)
   sklearn_pca_normalized = removeSmallerThanZero(sklearn_pca_normalized)


   #show_boxplot(sklearn_pca_normalized)
   #show_hist(sklearn_pca_normalized)

   # Kernel PCA
   # http://scikit-learn.org/stable/modules/generated/sklearn.decomposition.KernelPCA.html
   #sklearn_kernel_pca = sklearnKernelPCA(n_components=1,kernel='linear')
   #sklearn_kernel_pca = sklearn_kernel_pca.fit_transform(data.T)
   #print sklearn_kernel_pca.explained_variance_ratio_



   #print sklearn_pca.get_covariance()
   #show_hist(sklearn_pca_data)

   #sklearn_pca_data_normalized = sklearn.preprocessing.MinMaxScaler().fit_transform(sklearn_pca_data)
   #sklearn_pca_data_normalized = substractOne(sklearn_pca_data_normalized)

   #  Independent Component Analysis
   # http://scikit-learn.org/stable/modules/generated/sklearn.decomposition.FastICA.html#sklearn.decomposition.FastICA

   # FA
   # http://scikit-learn.org/stable/modules/generated/sklearn.decomposition.FactorAnalysis.html
   #sklearn_fa = sklearn.decomposition.FactorAnalysis(n_components=1)
   #sklearn_fa_data = sklearn_fa.fit_transform(data.T)
   #show_hist(sklearn_fa_data)


   """
   # push to carto
   i = 0
   cl.sql('BEGIN;')
   for pca in sklearn_transf:
      cl.sql('update budovy_index set pca = '+str(pca[0])+' where kod = '+str(kod[i])+";")
      i=i+1
   cl.sql('COMMIT;')
   """

   # export to file
   i=0
   file = open("data.csv","w")
   file.write("the_geom;kod;mo;pca;sum;zelen;frekventovana_silnice;znecisteni_ovzdusi;hluk;kontaminace\n")
   for pca in sklearn_pca_normalized:
      file.write(str(the_geom[i])+";"
                 +str(kod[i])+";"
                 +str(mo[i]) + ";"
                 +str(pca)+";"
                 +str(0.2*normalized_plocha_zelene_osm[i]+0.2*normalized_frekventovana_silnice_score[i]+0.2*normalized_znecisteni_ovzdusi_prekroceni[i]+0.2*normalized_hluk[i]+0.2*normalized_blizkost_kontaminace[i])+";"
                 +str(normalized_plocha_zelene_osm[i])+";"
                 +str(normalized_frekventovana_silnice_score[i])+";"
                 +str(normalized_znecisteni_ovzdusi_prekroceni[i])+";"
                 +str(normalized_hluk[i])+";"
                 +str(normalized_blizkost_kontaminace[i])+"\n")
      i = i + 1
   file.close()

except CartoDBException as e:
   print("some error ocurred", e)