<script>

function reloadMap(element_id){
  console.log("Reloading map: "+element_id);
  MyMap.drawer_selection = element_id;

  // remove old layers
  MyMap.map.eachLayer(function (layer) {
      MyMap.map.removeLayer(layer);
  });

  if(customData.getType(element_id)){
    console.log("Loading index map");
    MyMap.hashUrl = customData.getType(element_id);
    console.log("New hashUrl: "+MyMap.hashUrl);
    MyMap.is_index = true;
    showElement("#wizard_button");
    showElement("#menu_settings_button");
  }
  else{
    console.log("Loading variable map");
    MyMap.variable = customData.getVariable(element_id);
    MyMap.is_index = false;
    MyMap.table = getCorrespondingTable();
    hideElement("#wizard_button");
    hideElement("#menu_settings_button");
  }


  main();
}

  var MyMap = {};
  MyMap.currentLevel = null;
  MyMap.firstRun = true;
  MyMap.hash = null;
  MyMap.cartoCSS = null;
  MyMap.map = null;
  MyMap.cursor = null;
  MyMap.hashUrl = null;
  MyMap.is_index = null;
  MyMap.table = null;
  MyMap.wizardSlidersArray = null;
  MyMap.variable = null;
  MyMap.cartoDbSublayer = null;
  MyMap.fromCache = null;
  MyMap.serverUrl = "http://api.brno.ml/";
  MyMap.apiUrl ="http://api.brno.ml/generate_map";
  MyMap.algorithm_type = "sum";
  MyMap.colors = ['#b80000','#b83f00','#b87e00','#b2b800','#73b800','#34b800','#00b80a'];
  MyMap.numOfColors = 7;
  MyMap.binAlgorithm = "QuantileBins";
  MyMap.api_key = "API_KEY_HER";
  MyMap.basemap_layer_url = ["http://{s}.basemaps.cartocdn.com/light_all/{z}/{x}/{y}.png","http://{s}.basemaps.cartocdn.com/dark_all/{z}/{x}/{y}.png","http://mt0.google.com/vt/lyrs=y&hl=en&x={x}&y={y}&z={z}&s=Ga"];
  MyMap.basemap_layer_active = 0;
  MyMap.wizard_basic_modified = false;
  MyMap.dialog_page = null;
  MyMap.info_box_expanded = false;

  // init settings
  MyMap.currentLevel = 1;
  MyMap.table = getCorrespondingTable();
  MyMap.drawer_selection = "drawer_i_all";
  MyMap.hashUrl = "all";
  MyMap.results_table = "results_all";
  MyMap.api_data = api_data_all;
  MyMap.is_index = true;
  MyMap.advanced_legend = false;
  MyMap.pouze_obytne = 0;
  changeToolbarDrawerTitle(customData.getTitle("drawer_i_all"));
  hideElement('#wizard_basic_progressbar');

  init_scale_buttons();
  init_drawer_buttons();
  init_settings();
  init_sliders();
  init_tunes();
  init_info_box();
  init_toolbar_dialog();
  initWizard();
  initAboutProjectDialog();
  initSettingsLeonesDialog();
  initPouzeObytne();
  initSearch();



  // instantiate our map
  var map = new L.Map("map", {
      center: [49.195323,16.607889],
      zoom: 12,
      zoomControl:false,
  });
  MyMap.map = map;


  function main() {
    showLoading();

    // add base map
    var basemap_layer = L.tileLayer(MyMap.basemap_layer_url[MyMap.basemap_layer_active], {
      attribution: '',
    });
    basemap_layer.addTo(map);

    // flow: getHash() -> generateLegend() -> drawCartoMap()
    // if index generate gethash and generateLegend
    if(MyMap.is_index) {
        getHash(MyMap.api_data.getApiDataWithObytne(MyMap.hashUrl));
    }
    // if not only generate legend
    else {
      generateLegend();
    }

  }


  window.onload = main;
</script>
