// create layer selector

function initDataFilter(layer) {
  if(MyMap.is_index) {
    showDataFilter();
    get3Bins(layer);
  }
  else{
    hideDataFilter();
  }
}

function initPouzeObytne(){
  $("#checkbox-only-residential").click(function (){
    if(MyMap.pouze_obytne == 0){
      MyMap.pouze_obytne = 1;
    }
    else{
      MyMap.pouze_obytne = 0;
    }
    console.log("Changing pouze_obytne to: "+MyMap.pouze_obytne);
    reloadMap(MyMap.drawer_selection);
  });
}

function get3Bins(layer){
  var api_call = "http://cartodb.ml/user/blue4world/api/v2/sql?q=select unnest(CDB_"+MyMap.binAlgorithm+"(array_agg(distinct(("+MyMap.algorithm_type+"::numeric))), 3)) as buckets from (select * from "+MyMap.results_table+") _table_sql where value is not null and hash = "+"'"+MyMap.hash+"'"+"&api_key="+MyMap.api_key;

  $.getJSON(api_call, function(data) {
      console.log("Requesting bins from API.");
      var values = [];
      data.rows.forEach(function(row,i) {
          if(row.buckets) {
              values.push(myRound(row.buckets));
          }

      });
     console.log("3bins: ");
     console.log(values);
     createSelector(layer,values);
  });
}

function showDataFilter(){
  showElement('#layer_selector');
}

function hideDataFilter(){
  hideElement('#layer_selector');
}

function createSelector(layer,binValues) {
  var sql = new cartodb.SQL({
      user_name: 'blue4world',
      user: 'blue4world',
      type: 'cartodb',
      maps_api_template:"http://cartodb.ml:80/user/{user}",
      sql_api_template:"http://cartodb.ml:80/user/{user}",
      tiler_protocol:"http",
      tiler_domain:"cartodb.ml",
      tiler_port:80,
      sql_api_protocol:"http",
      sql_api_domain:"cartodb.ml",
      sql_api_endpoint:"/api/v2/sql",
      sql_api_port:80 });

  var $options = $('#layer_selector li');
  $options.click(function(e) {
    e.stopPropagation();
    // get the area of the selected layer
    var $li = $(e.target);
    var area = $li.attr('data');

    // deselect all and select the clicked one
    $options.removeClass('selected');
    $li.addClass('selected');

    // create query based on data from the layer
    //query = "SELECT * from (SELECT *, "+MyMap.algorithm_type+" as variable FROM "+MyMap.results_table+" where hash = "+"'"+MyMap.hash+"'"+") as data_table";
    query = "SELECT * from (SELECT *, "+MyMap.algorithm_type+" as variable FROM "+MyMap.results_table+" where hash = "+"'"+MyMap.hash+"'"+" and "+MyMap.algorithm_type+" > "+binValues[area]+") as data_table";


    if(area == 2) {
      query = "SELECT * from (SELECT *, "+MyMap.algorithm_type+" as variable FROM "+MyMap.results_table+" where hash = "+"'"+MyMap.hash+"'"+") as data_table";
    }


    console.log("Filtering query: "+query);
    // change the query in the layer to update the map
    layer.setSQL(query);
  });
}
