function generateCartoLayer() {

  if(MyMap.is_index) {
    run_sql = "SELECT * from (SELECT *, "+MyMap.algorithm_type+" as variable FROM "+MyMap.results_table+" where hash = "+"'"+MyMap.hash+"'"+") as data_table";
  }
  else{
      run_sql = "SELECT * from (SELECT *, "+MyMap.variable+" as variable FROM "+MyMap.table+") as data_table";
  }

  var layers = {
    user_name: 'blue4world',
    type: 'cartodb',
    maps_api_template:"http://cartodb.ml:80/user/{user}",
    sql_api_template:"http://cartodb.ml:80/user/{user}",
    tiler_protocol:"http",
    tiler_domain:"cartodb.ml",
    tiler_port:80,
    sql_api_protocol:"http",
    sql_api_domain:"cartodb.ml",
    sql_api_endpoint:"/api/v2/sql",
    sql_api_port:80,

    sublayers: [
                   {
                     //sql: "SELECT * from (SELECT budovy_index.cartodb_id, budovy_index.the_geom_webmercator, value as variable FROM budovy_index left join "+results_table+" on "+results_table+".kod = budovy_index.kod where hash = "+"'"+MyMap.hash+"'"+") as data_table",
                     sql: run_sql,
                     cartocss: MyMap.cartoCSS,
                     interactivity: "cartodb_id, kod"
                 }
     ]
  };
  return layers;
}


function drawCartoMap(){
  cartoLayerDefinition = generateCartoLayer();
  cartodb.createLayer(map, cartoLayerDefinition)
      .addTo(map)
      .done(function(layers) {


          /*
          Default seach bar
          var v = cdb.vis.Overlay.create('search', map.viz, {})
           v.show();
           $('#map').append(v.render().el);
        */

          // Adds the custom legend
          var customLegend = new cdb.geo.ui.Legend.Custom({
            title: customData.getTitle(MyMap.drawer_selection),
            data: MyMap.legendData
          });
          $("#advanced_legend").html('');
          $("#advanced_legend").append(customLegend.render().$el);
          $('#smile_legend_title').html(customData.getTitle(MyMap.drawer_selection));

      if(MyMap.advanced_legend) {
          showElement("#advanced_legend");
        }
        else{
          hideElement("#advanced_legend");
        }

          //for(i=0;i<7;i++){
            //$(".legend").find("li").eq(i).prepend(getHtmlEmotion(i));
            //$(".legend").find("li").find("div").eq(i).prepend(getHtmlEmotion(i));
          //}


          /*
           cartodb.vis.Vis.addInfowindow(map, layers.getSubLayer(0), ['variable'],
                      {
                        infowindowTemplate: $('#infowindow_template').html()
                     });
         */
         var sublayer = layers.getSubLayer(0);
                  sublayer.setInteraction(true);
                  sublayer.on('featureClick', function(event, latlng, pos, data){
                    //add here any action you want to perform on click
                    //console.log(data.kod);
                    getFeatureDetail(data.kod);
                  });

                  // set cursor type
                  sublayer.on('mouseover', function() {
                    if(MyMap.cursor != "mouseover") {
                        $('#map').css('cursor','default');
                        MyMap.cursor = "mouseover";
                    }
                  });

                  sublayer.on('mouseout', function() {
                      $('#map').css('cursor','-webkit-grab');
                      MyMap.cursor = "mouseout";

                  });

          initDataFilter(sublayer);

          hideLoading();

          if(MyMap.firstRun){
            showIntro();
            MyMap.firstRun = false;
          }

      })
      .error(function(err) {
          console.log(err);
      });



}
