function generateLegend() {

if(MyMap.is_index) {
  console.log("Bin Index api call");
  var api_call = "http://cartodb.ml/user/blue4world/api/v2/sql?q=select unnest(CDB_"+MyMap.binAlgorithm+"(array_agg(distinct(("+MyMap.algorithm_type+"::numeric))), "+MyMap.numOfColors+")) as buckets from (select * from "+MyMap.results_table+") _table_sql where value is not null and hash = "+"'"+MyMap.hash+"'"+"&api_key="+MyMap.api_key;
  getBinsFromApi(api_call);
}

else{
  console.log("Bin Variables api call: "+MyMap.variable);
  if(!isBoolVariable(MyMap.variable)){
      var api_call = "http://cartodb.ml/user/blue4world/api/v2/sql?q=select unnest(CDB_"+MyMap.binAlgorithm+"(array_agg(distinct(("+MyMap.variable+"::numeric))), "+MyMap.numOfColors+")) as buckets from (select * from "+MyMap.table+") _table_sql where "+MyMap.variable+" is not null&api_key="+MyMap.api_key;
      getBinsFromApi(api_call);
  }
  else {
      getBinaryBins();
  }
}

}

function getBinaryBins(){
  values = [];
  values.push(0.2);
  values.push(1.0);
  console.log("This table contains bool data");
  makeMap(values,true);
}

function getBinsFromApi(api_call){

  $.getJSON(api_call, function(data) {
      console.log("Requesting bins from API.");
      var values = [];
      data.rows.forEach(function(row,i) {
          if(row.buckets) {
              values.push(myRound(row.buckets));
          }

      });

      console.log("Bin algorithm: "+MyMap.binAlgorithm);
      console.log("Bins:");
      console.log(values);
      makeMap(values,false);

  });
}


function myRound(num) {
    return +(Math.round(num + "e+3")  + "e-3");
}

function makeMap(ranges,boolData) {

    var colors = [];
    if(boolData){
      colors = [];
      colors.push(MyMap.colors[0]);
      colors.push(MyMap.colors[MyMap.colors.length-1]);
    }
    else {
      colors = MyMap.colors;
    }

    if(!MyMap.is_index && isReverseVariable(MyMap.variable)){
        console.log("Reversing color scale: "+MyMap.variable);
        colors = colors.slice();
        colors.reverse();
    }


    var legendData = []; // array to hold legend data

    // build the cartoCSS
    var cartoCSSRules = '#data_table{' +
                        'polygon-opacity: 0.8;' +
                        'polygon-comp-op: lighten;' +
                        'line-color: #FFF;' +
                        'line-width: 0.5;' +
                        'line-opacity: 1;' +
                        '}';

    // loop backwards, high to low
    for(var i = ranges.length; i--;) {

        var value = ranges[i],
            color = colors[i];

        // build the individual rules
        var thisRule = '#data_table [ variable <= ' +
            value + '] { polygon-fill: ' + color + ';}'

        // add them to the cartoCSS
        cartoCSSRules += thisRule;

        // create a single object for the legend
        var legendClass = { name: ranges[i],  value: colors[i] };

        // push single object to legend data array
        legendData.push(legendClass);
    }
    MyMap.cartoCSS = cartoCSSRules;
    MyMap.legendData = legendData;
    drawCartoMap();
  }
  // 17 colors;
  //colors = ['#ff0000', '#ff2b00', '#ff5500', '#ff8000', '#ffaa00', '#ffd500', '#ffff00', '#d5ff00', '#aaff00', '#80ff00', '#55ff00', '#00ff00', '#00ffff', '#00d5ff', '#00aaff', '#0080ff', '#0055ff', '#0000ff' ];
  // carto classic
  //colors = ['#FFFFB2', '#FED976', '#FEB24C', '#FD8D3C', '#FC4E2A','#E31A1C', '#B10026'];
  // BRIGHT red -> orange -> green
  //colors = ['#00ff00','#54ff00','#aaff00','#ffff00','#ffaa00','#ff5400','#ff0000'];
  // DIMN red -> orange -> green
