function showWizard(){
    MyMap.dialog_page = "wizard";

    showToolbarDialog();
    
    document.querySelector('#wizard_advanced_progressbar').MaterialProgress.setProgress(0);
    ahp.progess_counter = 0;

    changeToolbarDialogTitle("Nastavení vah");

    //$('#wizard_button_icon').text("forward");
    //hideElement('#settings_button');

    hideElement('#wizard_button');
    showElement('#wizard');
    hideElement('#map');
    showElement('#wizard_basic_progressbar');


    $('#optionsList').empty();

    if(MyMap.hashUrl == "all") {
      loadAHPDataAll();
      startAHPAll();
    }
    else{
      loadAHPDataForIndex();
    }

}

function hideWizard(){
  MyMap.dialog_page = null;
  showToolbarDrawer();
  //$('#wizard_button_icon').text("tune");
  //showElement('#settings_button');
  showElement('#wizard_button');
  hideElement('#wizard_basic_progressbar');
  hideElement('#wizard');
  showElement('#map');
}

function addOptionsFromData(data){
  for (var property in data) {
      if (data.hasOwnProperty(property)) {
          if(!(data[property] instanceof Function)) {
            if(allowedInWizard(property,MyMap.hashUrl)) {
              displayHelper._addOption(customData.getAHPTitle(property));
            }
          }
      }
    }
}

function setCardTitleAndImage(hash){
  $("#tab_wizard_rozsirene_title").html(customData.getHashTitle(hash));
  imageUrl = '../img/'+hash+'.jpg';
  $("#wizard-ahp-title").css('background', 'url(' + imageUrl + ') center / cover');

}

function loadAHPDataAll(){
  MyMap.AHP_all = true;
  MyMap.AHP_load_data = [];
  MyMap.AHP_load_data.push("zivotni_prostredi");
  MyMap.AHP_load_data.push("socialni_statut");
  MyMap.AHP_load_data.push("relaxace");
  MyMap.AHP_load_data.push("doprava");
  MyMap.AHP_load_data.push("nakupy");
  MyMap.AHP_load_data_index = 0;
}

function startAHPAll() {
  setCardTitleAndImage(MyMap.AHP_load_data[MyMap.AHP_load_data_index]);
  addOptionsFromData(MyMap.api_data.getApiData(MyMap.AHP_load_data[MyMap.AHP_load_data_index]));
  displayHelper.startPoll();
}

function loadAHPDataForIndex(){
  MyMap.AHP_all = false;
  data = MyMap.api_data.getApiData(MyMap.hashUrl);
  setCardTitleAndImage(MyMap.hashUrl);
  addOptionsFromData(data);
  displayHelper.startPoll();
}


function wizardApplyAndHide(){
  if(MyMap.wizard_basic_modified){
    applyWizardSlidersSettings();
    reloadMap(MyMap.drawer_selection);
    MyMap.wizard_basic_modified = false;
  }
  hideWizard();
}

function initWizard(){
  initWizardBasicSliders();

  $( "#wizard_button_apply" ).click(function() {
      wizardApplyAndHide();
  });


  $( "#tab_wizard_zakladni_button" ).click(function() {
      showElement('#wizard_basic_progressbar');
  });

  $( "#tab_wizard_rozsirene_button" ).click(function() {
      hideElement('#wizard_basic_progressbar');
      document.querySelector('#wizard_advanced_progressbar').MaterialProgress.setProgress(0);
      ahp.progess_counter = 0;
  });


  $( "#wizard_button_reset" ).click(function() {
      wizardResetBasicSliders();
  });

  $( "#wizard_button" ).click(function() {
    showWizard(null);
  });


}


function AHPcalculationFinished(AHPdata) {
  console.log("AHP data:");
  console.log(AHPdata);
  applyAHPDataToApiData(AHPdata);

  if (MyMap.AHP_all == true){
    if(MyMap.AHP_load_data_index < MyMap.AHP_load_data.length-1){
      $('#optionsList').empty();
      MyMap.AHP_load_data_index += 1
      startAHPAll();
    }
    else{
      hideWizard();
      reloadMap(MyMap.drawer_selection);
    }
  }
  else {
    hideWizard();
    reloadMap(MyMap.drawer_selection);
  }
}

function applyAHPDataToApiData(AHPdata){
  for (var property in AHPdata) {
    if (AHPdata.hasOwnProperty(property)) {
        key = customData.getKeyForAHPTitle(property);
        MyMap.api_data[key] = AHPdata[property]*1;
    }
  }
  console.log("Data after AHP:")
  console.log(MyMap.api_data);

}

/*
function init_wizard_sliders(){
  $('.mdl-slider-wizard ').on('input',function(){
    id = jQuery(this).attr("id");
    x = getSliderWizardX(id);
    y = getSliderWizardY(id);
    result = convertToAHPScale(parseInt(this.value));
    MyMap.wizardSlidersArray[x][y] = result;
    MyMap.wizardSlidersArray[y][x] = 1.0/result;
    console.log(MyMap.wizardSlidersArray);
  });
}

function createArray(length) {
    var arr = new Array(length || 0),
        i = length;

    if (arguments.length > 1) {
        var args = Array.prototype.slice.call(arguments, 1);
        while(i--) arr[length-1 - i] = createArray.apply(this, args);
    }
    return arr;
}

function fillDiagonal(array){
    for (i = 0; i < 5; i++) {
        array[i][i] = 1;
    }
}

function getSliderWizardX(id){
  a = id.split('_');
  a.shift();
  return parseInt(a[0]);
}
function getSliderWizardY(id){
  a = id.split('_');
  a.shift();
  return parseInt(a[1]);
}

function convertToAHPScale(number){
  convert = {}
  convert[1] = 9;
  convert[2] = 7;
  convert[3] = 5;
  convert[4] = 3;
  convert[5] = 1;
  convert[6] = 1.0/3;
  convert[7] = 1.0/5;
  convert[8] = 1.0/7;
  convert[9] = 1.0/9;

  return convert[number];
}
*/
